'
' -----------------------------------------------------------------------------
' FreeBasic DEMO          Bitmap Info + Stats        Jan 15th,  2007   Jacques
' -----------------------------------------------------------------------------
'
' Based on BMP file format description at:
' http://www.fortunecity.com/skyscraper/windows/364/bmpffrmt.html
'
' Type INKBMP           ' Structure on Caller side 13 integers
'     fileSize as Long
'     dataSize As Long
'     Width As Long
'     Height As Long
'     PixelCount As Long
'     BitPerPixel As Long
'     totRed As Long
'     totBlue As Long
'     totGreen As Long
'     avgRed As Long
'     avgBlue As Long
'     avgGreen As Long
' END TYPE
'
' Return:    0 = OK
'            1 = ERROR NOT A BITMAP FILE
'            2 = ERROR NOT A 24 BIT PER PIXEL BMP
'            3 = WARNING BMP SIZE > 7812000 PIXELS: iTotRgb may overflow
'            4 = ERROR UNKNOWN METHOD (1 to 3 allowed)
' -----------------------------------------------------------------------------
'
Option Explicit
Option ByVal
'
Function BitmapWork (ptrBMP As Integer, ptrResult As Integer Ptr, Method as Integer, a4) As Long
    Dim As Short bmpTag, bmpBitPerPixel
    Dim As Integer i, hBmpFile, bmpFileSize, bmpWidth, bmpHeight, bmpSize, bmpPtr, bmpPixelCount
    Dim As UInteger iTotRed, iTotGreen, iTotBlue, ptrBmpDatas
    ' 
    ' Get Bimap informations
    ' ----------------------
    bmpTag = *cptr(Integer ptr, ptrBmp)    'cptr(Short ptr, ptrBmp)[0]
    If bmpTag <> 19778 Then     ' 19778 = "BM"  is a bmp file signature
        Function = 1
        Exit Function
    End If
    bmpFileSize    = *cptr(UInteger ptr, ptrBmp +  2)
    bmpPtr         = *cptr(UInteger ptr, ptrBmp + 10)
    bmpWidth       = *cptr(UInteger ptr, ptrBmp + 18)
    bmpHeight      = *cptr(UInteger ptr, ptrBmp + 22)
    bmpBitPerPixel = *cptr(UShort   ptr, ptrBmp + 28)
    If bmpBitPerPixel <> 24 Then
        Function = 2
        Exit Function 
    End If
    bmpSize = *cptr(Integer ptr, ptrBmp + 34)
    '
    bmpPixelCount = bmpWidth * bmpHeight
    ptrBmpDatas = ptrBmp + bmpPtr - 1
    '
    ' Set BMP File Info in Result structure
    ' -------------------------------------
    ptrResult[0] = bmpFileSize
    ptrResult[1] = bmpSize
    ptrResult[2] = bmpWidth
    ptrResult[3] = bmpHeight
    ptrResult[4] = bmpPixelCount
    ptrResult[5] = bmpBitPerPixel
    ' 
    ' Sum RGB value (4 different Methods)
    ' -------------
    iTotRed   = 0
    iTotGreen = 0
    iTotBlue  = 0
    '
    Select Case Method
        ' Get Pixels in File Buffer using Freebasic code  1000 Times faster than 1
        Case 1
            For i = ptrBmpDatas To ptrBmpDatas + bmpSize Step 3
                iTotRed   += *cptr(UByte ptr, i)
                iTotBlue  += *cptr(UByte ptr, i + 1)
                iTotGreen += *cptr(UByte ptr, i + 2)
            Next i
        ' Assembler Code not optimized    5000 times faster than 1
        Case 2
            asm
                pusha
                mov ecx, [bmpSize]
'                sub ecx, 3
                mov esi, [ptrBmpDatas]        
                xxLoopBitmap:
                    xor eax, eax
                    mov al, [esi]
                    add [iTotRed], eax
                    xor eax, eax
                    mov al, [esi + 1]
                    add [iTotBlue], eax
                    xor eax, eax
                    mov al, [esi + 2]
                    add [iTotGreen], eax
                    add esi, 3
                    sub ecx, 3
                jnc xxLoopBitmap
                popa
            end asm
        ' Assembler Code ???Optimized    not very different from Method 3
        Case 3
            asm
                pusha
                mov ecx, [bmpSize]
'                sub ecx, 3
                mov esi, [ptrBmpDatas]        
                xxxLoopBitmap:
                    xor eax, eax
                    mov eax, [esi]
                    xor ebx, ebx
                    mov bl, al
                    add dword ptr [iTotRed], ebx
                    mov bl, ah
                    add dword ptr [iTotBlue], ebx
                    shr eax, 16
                    mov bl, al
                    add dword ptr [iTotGreen], ebx
                    add esi, 3
                    sub ecx, 3
                jnc xxxLoopBitmap
                popa
            end asm
        Case Else
	       Function = 4
            Exit Function
    End Select
'
    ptrResult[6]  = iTotRed
    ptrResult[7]  = iTotBlue
    ptrResult[8]  = iTotGreen
    ptrResult[9]  = iTotRed\bmpPixelCount
    ptrResult[10] = iTotBlue\bmpPixelCount
    ptrResult[11] = iTotGreen\bmpPixelCount
    Function = IIf (bmpPixelCount > 7812000, 3, 0)
End Function
' -----------------------------------------------------------------------------
'
